
#ifndef __ARCH_ARM_SRC_SMARTFUSION2_CHIP_SF2_SPI_H
#define __ARCH_ARM_SRC_SMARTFUSION2_CHIP_SF2_SPI_H

#include "chip.h"
#include <nuttx/config.h>
#include <nuttx/spi/spi.h>

/* Register Offsets ***********************************************************/
 
#define SF2_SPI_CONTROL_OFFSET 0x0000
#define SF2_SPI_TXRXDF_SIZE_OFFSET 0x0004
#define SF2_SPI_STATUS_OFFSET 0x0008
#define SF2_SPI_INT_CLEAR_OFFSET 0x000c
#define SF2_SPI_RX_DATA_OFFSET 0x0010
#define SF2_SPI_TX_DATA_OFFSET 0x0014
#define SF2_SPI_CLK_GEN_OFFSET 0x0018
#define SF2_SPI_SLAVE_SELECT_OFFSET 0x001c
#define SF2_SPI_MIS_OFFSET 0x0020
#define SF2_SPI_RIS_OFFSET 0x0024
#define SF2_SPI_CONTROL2_OFFSET 0x0028
#define SF2_SPI_COMMAND_OFFSET 0x002c
#define SF2_SPI_PKTSIZE_OFFSET 0x0030
#define SF2_SPI_CMD_SIZE_OFFSET 0x0034
#define SF2_SPI_HWSTATUS_OFFSET 0x0038
#define SF2_SPI_STAT8_OFFSET 0x003c
#define SF2_SPI_CTRL0_OFFSET 0x0040
#define SF2_SPI_CTRL1_OFFSET 0x0044
#define SF2_SPI_CTRL2_OFFSET 0x0048
#define SF2_SPI_CTRL3_OFFSET 0x004c

/* Register Addresses *********************************************************/

#define SF2_SPI0_CONTROL (SF2_SPI0_BASE + SF2_SPI_CONTROL_OFFSET)
#define SF2_SPI0_TXRXDF_SIZE (SF2_SPI0_BASE + SF2_SPI_TXRXDF_SIZE_OFFSET)
#define SF2_SPI0_STATUS (SF2_SPI0_BASE + SF2_SPI_STATUS_OFFSET)
#define SF2_SPI0_INT_CLEAR (SF2_SPI0_BASE + SF2_SPI_INT_CLEAR_OFFSET)
#define SF2_SPI0_RX_DATA (SF2_SPI0_BASE + SF2_SPI_RX_DATA_OFFSET)
#define SF2_SPI0_TX_DATA (SF2_SPI0_BASE + SF2_SPI_TX_DATA_OFFSET)
#define SF2_SPI0_CLK_GEN (SF2_SPI0_BASE + SF2_SPI_CLK_GEN_OFFSET)
#define SF2_SPI0_SLAVE_SELECT (SF2_SPI0_BASE + SF2_SPI_SLAVE_SELECT_OFFSET)
#define SF2_SPI0_MIS (SF2_SPI0_BASE + SF2_SPI_MIS_OFFSET)
#define SF2_SPI0_RIS (SF2_SPI0_BASE + SF2_SPI_RIS_OFFSET)
#define SF2_SPI0_CONTROL2 (SF2_SPI0_BASE + SF2_SPI_CONTROL2_OFFSET)
#define SF2_SPI0_COMMAND (SF2_SPI0_BASE + SF2_SPI_COMMAND_OFFSET)
#define SF2_SPI0_PKTSIZE (SF2_SPI0_BASE + SF2_SPI_PKTSIZE_OFFSET)
#define SF2_SPI0_CMD_SIZE (SF2_SPI0_BASE + SF2_SPI_CMD_SIZE_OFFSET)
#define SF2_SPI0_HWSTATUS (SF2_SPI0_BASE + SF2_SPI_HWSTATUS_OFFSET)
#define SF2_SPI0_STAT8 (SF2_SPI0_BASE + SF2_SPI_STAT8_OFFSET)
#define SF2_SPI0_CTRL0 (SF2_SPI0_BASE + SF2_SPI_CTRL0_OFFSET)
#define SF2_SPI0_CTRL1 (SF2_SPI0_BASE + SF2_SPI_CTRL1_OFFSET)
#define SF2_SPI0_CTRL2 (SF2_SPI0_BASE + SF2_SPI_CTRL2_OFFSET)
#define SF2_SPI0_CTRL3 (SF2_SPI0_BASE + SF2_SPI_CTRL3_OFFSET)

#define SF2_SPI1_CONTROL (SF2_SPI1_BASE + SF2_SPI_CONTROL_OFFSET)
#define SF2_SPI1_TXRXDF_SIZE (SF2_SPI1_BASE + SF2_SPI_TXRXDF_SIZE_OFFSET)
#define SF2_SPI1_STATUS (SF2_SPI1_BASE + SF2_SPI_STATUS_OFFSET)
#define SF2_SPI1_INT_CLEAR (SF2_SPI1_BASE + SF2_SPI_INT_CLEAR_OFFSET)
#define SF2_SPI1_RX_DATA (SF2_SPI1_BASE + SF2_SPI_RX_DATA_OFFSET)
#define SF2_SPI1_TX_DATA (SF2_SPI1_BASE + SF2_SPI_TX_DATA_OFFSET)
#define SF2_SPI1_CLK_GEN (SF2_SPI1_BASE + SF2_SPI_CLK_GEN_OFFSET)
#define SF2_SPI1_SLAVE_SELECT (SF2_SPI1_BASE + SF2_SPI_SLAVE_SELECT_OFFSET)
#define SF2_SPI1_MIS (SF2_SPI1_BASE + SF2_SPI_MIS_OFFSET)
#define SF2_SPI1_RIS (SF2_SPI1_BASE + SF2_SPI_RIS_OFFSET)
#define SF2_SPI1_CONTROL2 (SF2_SPI1_BASE + SF2_SPI_CONTROL2_OFFSET)
#define SF2_SPI1_COMMAND (SF2_SPI1_BASE + SF2_SPI_COMMAND_OFFSET)
#define SF2_SPI1_PKTSIZE (SF2_SPI1_BASE + SF2_SPI_PKTSIZE_OFFSET)
#define SF2_SPI1_CMD_SIZE (SF2_SPI1_BASE + SF2_SPI_CMD_SIZE_OFFSET)
#define SF2_SPI1_HWSTATUS (SF2_SPI1_BASE + SF2_SPI_HWSTATUS_OFFSET)
#define SF2_SPI1_STAT8 (SF2_SPI1_BASE + SF2_SPI_STAT8_OFFSET)
#define SF2_SPI1_CTRL0 (SF2_SPI1_BASE + SF2_SPI_CTRL0_OFFSET)
#define SF2_SPI1_CTRL1 (SF2_SPI1_BASE + SF2_SPI_CTRL1_OFFSET)
#define SF2_SPI1_CTRL2 (SF2_SPI1_BASE + SF2_SPI_CTRL2_OFFSET)
#define SF2_SPI1_CTRL3 (SF2_SPI1_BASE + SF2_SPI_CTRL3_OFFSET)

/* Register Bitfield Definitions **********************************************/

/* SPI CONTROL register */

#define SPI_CONTROL_ENABLE (1 << 0)
#define SPI_CONTROL_MODE (1 << 1)

#define SPI_CONTROL_TRANSFPTRL_SHIFT (2)
#define SPI_CONTROL_TRANSFPTRL_MASK (3 << SPI_CONTROL_TRANSFPTRL_SHIFT)
#define SPI_CONTROL_MS (0 << SPI_CONTROL_TRANSFPTRL_SHIFT)
#define SPI_CONTROL_TS (1 << SPI_CONTROL_TRANSFPTRL_SHIFT)
#define SPI_CONTROL_NSM (2 << SPI_CONTROL_TRANSFPTRL_SHIFT)

#define SPI_CONTROL_INTRXDATA (1 << 4)
#define SPI_CONTROL_INTTXDATA (1 << 5)
#define SPI_CONTROL_INTRXOVRFLO (1 << 6)
#define SPI_CONTROL_INTTXTURUN (1 << 7)

#define SPI_CONTROL_TXRXDFCOUNT_SHIFT (8)
#define SPI_CONTROL_TXRXDFCOUNT_MASK (0xffff << SPI_CONTROL_TXRXDFCOUNT_SHIFT)

#define SPI_CONTROL_SPO (1 << 24)
#define SPI_CONTROL_SPH (1 << 25)
#define SPI_CONTROL_SPS (1 << 26)
#define SPI_CONTROL_FRAMEURUN (1 << 27)
#define SPI_CONTROL_CLKMODE (1 << 28)
#define SPI_CONTROL_BIGFIFO (1 << 29)
#define SPI_CONTROL_OENOFF (1 << 30)
#define SPI_CONTROL_RESET (1 << 31)

/* SPI STATUS register */

#define SPI_STATUS_TXDATSEND (1 << 0)
#define SPI_STATUS_RXDATRCED (1 << 1)
#define SPI_STATUS_RXOVERFLOW (1 << 2)
#define SPI_STATUS_TXUNDERRUN (1 << 3)
#define SPI_STATUS_RXFIFOFUL (1 << 4)
#define SPI_STATUS_RXFIFOFULNXT (1 << 5)
#define SPI_STATUS_RXFIFOEMP (1 << 6)
#define SPI_STATUS_RXFIFOEMPNXT (1 << 7)
#define SPI_STATUS_TXFIFOFUL (1 << 8)
#define SPI_STATUS_TXFIFOFULNXT (1 << 9)
#define SPI_STATUS_TXFIFOEMP (1 << 10)
#define SPI_STATUS_TXFIFOEMPNXT (1 << 11)
#define SPI_STATUS_FRAMESTART (1 << 12)
#define SPI_STATUS_SSEL (1 << 13)
#define SPI_STATUS_ACTIVE (1 << 14)

/* SPI INTERRUPT CLEAR register */

#define SPI_INT_CLEAR_TXDONECLR (1 << 0)
#define SPI_INT_CLEAR_RXRDYCLR (1 << 1)
#define SPI_INT_CLEAR_RXCHOVRFLW (1 << 2)
#define SPI_INT_CLEAR_TXCHUNDRUN (1 << 3)
#define SPI_INT_CLEAR_CMDINT (1 << 4)
#define SPI_INT_CLEAR_SSEND (1 << 5)

/* SPI MASKED INTERRUPT STATUS register */

#define SPI_MIS_TXDONEMSKINT (1 << 0)
#define SPI_MIS_RXRDYEMSKINT (1 << 1)
#define SPI_MIS_RXCHOVRFMSKINT (1 << 2)
#define SPI_MIS_TXCHUNDDMSKINT (1 << 3)
#define SPI_MIS_CMDINT (1 << 4)
#define SPI_MIS_SSEND (1 << 5)

/* spi raw interrupt status register */

#define SPI_RIS_TXDONE (1 << 0)
#define SPI_RIS_RXRDY (1 << 1)
#define SPI_RIS_RXCHOVRF (1 << 2)
#define SPI_RIS_TXCHUNDR (1 << 3)
#define SPI_RIS_CMDINT (1 << 4)
#define SPI_RIS_SSEND (1 << 5)

/* spi control2 register */

#define SPI_CONTROL2_AUTOSTATUS (1 << 0)
#define SPI_CONTROL2_AUTOPULL (1 << 1)
#define SPI_CONTROL2_DISFRMCNT (1 << 2)

#define SPI_CONTROL2_INTEN_CMD (1 << 4)
#define SPI_CONTROL2_INTEN_SSEND (1 << 5)

/* spi command register */

#define SPI_COMMAND_AUTOFILL (1 << 0)
#define SPI_COMMAND_AUTOEMPTY (1 << 1)
#define SPI_COMMAND_RXFIFORST (1 << 2)
#define SPI_COMMAND_TXFIFORST (1 << 3)
#define SPI_COMMAND_CLRFRAMECNT (1 << 4)
#define SPI_COMMAND_AUTOSTALL (1 << 5)
#define SPI_COMMAND_TXNOW (1 << 6)


#endif /* __ARCH_ARM_SRC_SMARTFUSION2_CHIP_SF2_SPI_H */
